java异常判断_Java异常类

异常指不期而至的各种状况,如:文件找不到、网络连接失败、非法参数等。异常是一个事件,它发生在程序运行期间,干扰了正常的指令流程。Java通 过API中Throwable类的众多子类描述各种不同的异常。因而,Java异常都是对象,是Throwable子类的实例,描述了出现在一段编码中的 错误条件。当条件生成时,错误将引发异常。

Java异常类层次结构图:

c8b0274c85d5e3dbd2349d18bfe0f70f.png

在 Java 中,所有的异常都有一个共同的祖先 Throwable(可抛出)。Throwable 指定代码中可用异常传播机制通过 Java 应用程序传输的任何问题的共性。

Throwable: 有两个重要的子类:Exception(异常)和 Error(错误),二者都是 Java 异常处理的重要子类,各自都包含大量子类。

Error(错误):是程序无法处理的错误,表示运行应用程序中较严重问题。大多数错误与代码编写者执行的操作无关,而表示代码运行时 JVM(Java 虚拟机)出现的问题。例如,Java虚拟机运行错误(Virtual MachineError),当 JVM 不再有继续执行操作所需的内存资源时,将出现 OutOfMemoryError。这些异常发生时,Java虚拟机(JVM)一般会选择线程终止。

这些错误表示故障发生于虚拟机自身、或者发生在虚拟机试图执行应用时,如Java虚拟机运行错误(Virtual MachineError)、类定义错误(NoClassDefFoundError)等。这些错误是不可查的(因为不知道什么时候会出现这类问题,不好指定同时也没有定义),因为它们在应用程序的控制和处理能力之 外,而且绝大多数是程序运行时不允许出现的状况。对于设计合理的应用程序来说,即使确实发生了错误,本质上也不应该试图去处理它所引起的异常状况。在 Java中,错误通过Error的子类描述。

Exception(异常):是程序本身可以处理的异常(很多错误提前可以预知如除数为0就会报错)。

Exception 类有一个重要的子类 RuntimeException。RuntimeException 类及其子类表示“JVM 常用操作”引发的错误。例如,若试图使用空值对象引用、除数为零或数组越界,则分别引发运行时异常(NullPointerException、ArithmeticException)和 ArrayIndexOutOfBoundException。

注意:异常和错误的区别:异常能被程序本身可以处理,错误是无法处理。

Java的异常(包括Exception和Error)按照编译器是否在编译期间检查分为可查的异常(checked exceptions)和不可查的异常(unchecked exceptions)。

可查异常(编译器要求必须处置的异常):正确的程序在运行中,很容易出现的、情理可容的异常状况。可查异常虽然是异常状况,但在一定程度上它的发生是可以预计的,而且一旦发生这种异常状况,就必须采取某种方式进行处理。

除了RuntimeException及其子类(编译器不做检查如空指针异常)以外,其他的Exception类及其子类都属于可查异常。这种异常的特点是Java编译器会检查它,也就是说,当程序中可能出现这类异常,要么用try-catch语句捕获它,要么用throws子句声明抛出它,否则编译不会通过。

不可查异常(编译器不要求强制处置的异常):包括运行时异常(RuntimeException与其子类)和错误(Error)。

Exception 这种异常分两大类运行时异常和非运行时异常(编译异常)。程序中应当尽可能去处理这些异常。

按照程序执行的过程划分

运行时异常:都是RuntimeException类及其子类异常,如NullPointerException(空指针异常)、IndexOutOfBoundsException(下标越界异常)等,这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理。这些异常一般是由程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生。运行时异常的特点是Java编译器不会检查它,也就是说,当程序中可能出现这类异常,即使没有用try-catch语句捕获它,也没有用throws子句声明抛出它,也会编译通过(  如果所有方法都层层上抛获取的异常,最终JVM会进行处理,处理也很简单,就是打印异常消息和堆栈信息。如果抛出的是Error或RuntimeException,则该方法的调用者可选择处理该异常)。

非运行时异常 (编译异常):是RuntimeException以外的异常,类型上都属于Exception类及其子类。从程序语法角度讲是必须进行处理的异常,如果不处理,程序就不能编译通过。如IOException、SQLException等以及用户自定义的Exception异常,一般情况下不自定义检查异常。

Java中的异常处理机制

在 Java 应用程序中,异常处理机制为:抛出异常,捕捉异常。

抛出异常:当一个方法出现错误引发异常时,方法创建异常对象并交付运行时系统,异常对象中包含了异常类型和异常出现时的程序状态等异常信息。运行时系统负责寻找处置异常的代码并执行。

捕获异常:在方法抛出异常之后,运行时系统将转为寻找合适的异常处理器(exception handler)。潜在的异常处理器是异常发生时依次存留在调用栈中的方法的集合。当异常处理器所能处理的异常类型与方法抛出的异常类型相符时,即为合适 的异常处理器。运行时系统从发生异常的方法开始,依次回查调用栈中的方法,直至找到含有合适异常处理器的方法并执行。当运行时系统遍历调用栈而未找到合适 的异常处理器,则运行时系统终止。同时,意味着Java程序的终止。

对于运行时异常、错误或可查异常,Java技术所要求的异常处理方式有所不同。

由于运行时异常(RuntimeException及其子类)的不可查性,为了更合理、更容易地实现应用程序,Java规定,运行时异常将由Java运行时系统自动抛出,允许应用程序忽略运行时异常(如:“除数为0”等ArithmeticException,是RuntimException的子类。而运行时异常将由运行时系统自动抛出,不需要使用throw语句)。

对于方法运行中可能出现的Error,当运行方法不欲捕捉时,Java允许该方法不做任何抛出声明。因为,大多数Error异常属于永远不能被允许发生的状况,也属于合理的应用程序不该捕捉的异常(在编写程序时不需要考虑Error)。

对于所有的可查异常(除了RuntimeException及其子类),Java规定:一个方法必须捕捉,或者声明抛出方法之外。也就是说,当一个方法选择不捕捉可查异常时,它必须声明将抛出异常,因为Java编译器会检查它,也就是说,当程序中可能出现这类异常,要么用try-catch语句捕获它,要么用throws子句声明抛出它,否则编译不会通过。

能够捕捉异常的方法,需要提供相符类型的异常处理器。所捕捉的异常,可能是由于自身语句所引发并抛出的异常,也可能是由某个调用的方法或者Java运行时 系统等抛出的异常。也就是说,一个方法所能捕捉的异常,一定是Java代码在某处所抛出的异常。简单地说,异常总是先被抛出,后被捕捉的。

任何Java代码都可以抛出异常,如:自己编写的代码、来自Java开发环境包中代码,或者Java运行时系统。无论是谁,都可以通过Java的throw语句抛出异常。

1.从方法中抛出的任何异常都必须使用throws子句。

2.捕捉异常通过try-catch语句或者try-catch-finally语句实现。

3.总体来说,Java规定:对于可查异常必须捕捉、或者声明抛出(throw)。允许忽略不可查的RuntimeException和Error。

例1:

packagecn.czbk.no9;public classExceprtionTest {/***@paramargs*/

public static voidmain(String[] args) {int a=6;int b=0;/*** 除数为0,属于RuntimeException,属于不可查异常

* 编译器不会对其做检查。

* 运行时异常由系统jvm自动抛出不需要主动throw*/

int c=a/b;

System.out.println(c);

}

}

运行时异常由系统即JVM主动抛出不需要手动throw

0b1cfcfa6a7a09b0b32bcb89872077ac.png

那么我们要让程序正常通过,就要处理这个运行时异常。

packagecn.czbk.no9;public classExceprtionTest {/***@paramargs*/

public static voidmain(String[] args) {int a=6;int b=2;/*** 除数为0,属于RuntimeException,属于不可查异常

* 编译器不会对其做检查。

* 运行时异常由系统jvm自动抛出不需要主动throw*/

try{if(b==0){//在运行过程中出现的异常都是属于上面讲的异常类的实例

throw newArithmeticException();//由于是RuntimeException所以可以不用显示抛出

}else{

System.out.println("a/b="+(a/b));

}

}catch(ArithmeticException e) {//TODO: handle exception

System.out.println("除数不能为0");

}

System.out.println("程序正常结束!");

}

}

try-catch-finally语句

try{//可能会发生异常的程序代码

} catch(Type1 id1) {//捕获并处理try抛出的异常类型Type1

} catch(Type2 id2) {//捕获并处理try抛出的异常类型Type2

} finally{//无论是否发生异常,都将执行的语句块

}

实例:

packagecn.czbk.no9;importjava.util.Scanner;public classExceptionTest1 {public static voidmain(String[] args) {int[] intArray = new int[4];int a = 20;int c=0;//数组初始化赋值

for (int i = 0; i <= 3; i++) {

intArray[i]=i;

}//根据输入的值判断循环次数

Scanner in=newScanner(System.in);

String text=in.nextLine();//将输入的String转为Int

int x=Integer.parseInt(text);for (int i = x; i >= 0; i--) {//将不可查异常即RuntimeException进行捕获处理

try{int b =intArray[i];

c=a/b;

}/*** 如果抛出的异常对象属于catch子句的异常类,或者属于该异常类的子类,则认为生成的异常对象与catch块捕获的异常类型相匹配。

* 一旦某个catch捕获到匹配的异常类型,将进入异常处理代码。

* 一经处理结束,就意味着整个try-catch语句结束。

* 其他的catch子句不再有匹配和捕获异常类型的机会。

* 对于有多个catch子句的异常程序而言,应该尽量将捕获底层异常类的catch子 句放在前面,

* 同时尽量将捕获相对高层的异常类的catch子句放在后面。

* 否则,捕获底层异常类的catch子句将可能会被屏蔽。*/

catch(ArrayIndexOutOfBoundsException e) {//TODO: handle exception

System.out.println("数组下标越界,原数组中没有intArray["+i+"]");

}catch(ArithmeticException e) {//TODO: handle exception

System.out.println("intArray[" + i + "]" + "除数不能为0");

}catch(Exception e) {//TODO: handle exception

System.out.println("其他未想到的运行时异常");

}finally{

System.out.println("i为"+i+"计算结果 a/b="+a+"/"+intArray[i]+"="+c);

}

}

}

}

总结:

try 块:用于捕获异常。其后可接零个或多个catch块,如果没有catch块,则必须跟一个finally块。

catch 块:用于处理try捕获到的异常。

finally 块:无论是否捕获或处理异常,finally块里的语句都会被执行。当在try块或catch块中遇到return语句时,finally语句块将在方法返回之前被执行。在以下4种特殊情况下,finally块不会被执行:

1)在finally语句块中发生了异常。

2)在前面的代码中用了System.exit()退出程序。

3)程序所在的线程死亡。

4)关闭CPU。

8aea6ba2f9b2295f6843d44839562bc2.png

抛出异常

1. throws抛出异常

methodname throwsException1,Exception2,..,ExceptionN

{

}

方法名后的throws Exception1,Exception2,...,ExceptionN 为声明要抛出的异常列表。当方法抛出异常列表的异常时,方法将不对这些类型及其子类类型的异常作处理,而抛向调用该方法的方法,由他去处理。例如:

Throws抛出异常的规则:

1) 如果是不可查异常(unchecked exception),即Error、RuntimeException或它们的子类,那么可以不使用throws关键字来声明要抛出的异常,编译仍能顺利通过,但在运行时会被系统抛出。

2)必须声明方法可抛出的任何可查异常(checked exception)。即如果一个方法可能出现受可查异常,要么用try-catch语句捕获,要么用throws子句声明将它抛出,否则会导致编译错误

3)仅当抛出了异常,该方法的调用者才必须处理或者重新抛出该异常。当方法的调用者无力处理该异常的时候,应该继续抛出,而不是囫囵吞枣。

4)调用方法必须遵循任何可查异常的处理和声明规则。若覆盖一个方法,则不能声明与覆盖方法不同的异常。声明的任何异常必须是被覆盖方法所声明异常的同类或子类。

2. 使用throw抛出异常

void method1() throws IOException{} //合法//编译错误,必须捕获或声明抛出IOException

voidmethod2(){

method1();

}//合法,声明抛出IOException

void method3()throwsIOException {

method1();

}//合法,声明抛出Exception,IOException是Exception的子类

void method4()throwsException {

method1();

}//合法,捕获IOException

voidmethod5(){try{

method1();

}catch(IOException e){…}

}//编译错误,必须捕获或声明抛出Exception

voidmethod6(){try{

method1();

}catch(IOException e){throw newException();}

}//合法,声明抛出Exception

void method7()throwsException{try{

method1();

}catch(IOException e){throw newException();}

}

判断一个方法可能会出现异常的依据如下:

1)方法中有throw语句。例如,以上method7()方法的catch代码块有throw语句。

2)调用了其他方法,其他方法用throws子句声明抛出某种异常。例如,method3()方法调用了method1()方法,method1()方法声明抛出IOException,因此,在method3()方法中可能会出现IOException。

throw总是出现在函数体中,用来抛出一个Throwable类型的异常。程序会在throw语句后立即终止,它后面的语句执行不到,然后在包含它的所有try块中(可能在上层调用函数中)从里向外寻找含有与其匹配的catch子句的try块。

我们知道,异常是异常类的实例对象,我们可以创建异常类的实例对象通过throw语句抛出。该语句的语法格式为:

throw new exceptionname;

例如抛出一个IOException类的异常对象:

throw new IOException;

要注意的是,throw 抛出的只能够是可抛出类Throwable 或者其子类的实例对象。下面的操作是错误的:

throw new String("exception");

这是因为String 不是Throwable 类的子类。

如果抛出了检查异常,则还应该在方法头部声明方法可能抛出的异常类型。该方法的调用者也必须检查处理抛出的异常。

如果所有方法都层层上抛获取的异常,最终JVM会进行处理,处理也很简单,就是打印异常消息和堆栈信息。如果抛出的是Error或RuntimeException,则该方法的调用者可选择处理该异常。

packagecn.czbk.no9;public classExceptionTest3 {public void pop() throwsMyException{

String s="测试用";throw newMyException(s);

}public static void main(String[] args) throwsMyException{

ExceptionTest3 et=newExceptionTest3();

et.pop();

}

}class MyException extendsException{

String message;publicMyException(String errorMessage){

message=errorMessage;

}publicString getMessage(){returnmessage;

}

}

在main函数继续抛出的话会在运行后会显示如下内容

885afa5e1ecff882a1d59e8a39f18f63.png

如果不抛出而是选择处理的话如下所示

packagecn.czbk.no9;public classExceptionTest3 {public void pop() throwsMyException{

String s="测试用";throw newMyException(s);

}public static voidmain(String[] args){

ExceptionTest3 et=newExceptionTest3();try{

et.pop();

}catch(MyException e) {//TODO: handle exception

e.getPrintMessage();

}

}

}class MyException extendsException{

String message;publicMyException(String errorMessage){

message=errorMessage;

}public voidgetPrintMessage(){

System.out.println(message);

}

}

c8263d3dfa03021848ec9c759817a195.png

4.4 Throwable类中的常用方法

注意:catch关键字后面括号中的Exception类型的参数e。Exception就是try代码块传递给catch代码块的变量类型,e就是变量名。catch代码块中语句"e.getMessage();"用于输出错误性质。通常异常处理常用3个函数来获取异常的有关信息:

getCause():返回抛出异常的原因。如果 cause 不存在或未知,则返回 null。

getMeage():返回异常的消息信息。

printStackTrace():对象的堆栈跟踪输出至错误输出流,作为字段 System.err 的值。

有时为了简单会忽略掉catch语句后的代码,这样try-catch语句就成了一种摆设,一旦程序在运行过程中出现了异常,就会忽略处理异常,而错误发生的原因很难查找。

Java常见异常

在Java中提供了一些异常用来描述经常发生的错误,对于这些异常,有的需要程序员进行捕获处理或声明抛出,有的是由Java虚拟机自动进行捕获处理。Java中常见的异常类:

1.RuntimeException子类:

1、 java.lang.ArrayIndexOutOfBoundsException

数组索引越界异常。当对数组的索引值为负数或大于等于数组大小时抛出。

2、java.lang.ArithmeticException

算术条件异常。譬如:整数除零等。

3、java.lang.NullPointerException

空指针异常。当应用试图在要求使用对象的地方使用了null时,抛出该异常。譬如:调用null对象的实例方法、访问null对象的属性、计算null对象的长度、使用throw语句抛出null等等

4、java.lang.ClassNotFoundException

找不到类异常。当应用试图根据字符串形式的类名构造类,而在遍历CLASSPAH之后找不到对应名称的class文件时,抛出该异常。

5、java.lang.NegativeArraySizeException  数组长度为负异常

6、java.lang.ArrayStoreException 数组中包含不兼容的值抛出的异常

7、java.lang.SecurityException 安全性异常

8、java.lang.IllegalArgumentException 非法参数异常

2.IOException

IOException:操作输入流和输出流时可能出现的异常。

EOFException   文件已结束异常

FileNotFoundException   文件未找到异常

3.其他

ClassCastException    类型转换异常类

ArrayStoreException  数组中包含不兼容的值抛出的异常

SQLException   操作数据库异常类

NoSuchFieldException   字段未找到异常

NoSuchMethodException   方法未找到抛出的异常

NumberFormatException    字符串转换为数字抛出的异常

StringIndexOutOfBoundsException 字符串索引超出范围抛出的异常

IllegalAccessException  不允许访问某类异常

InstantiationException  当应用程序试图使用Class类中的newInstance()方法创建一个类的实例,而指定的类对象无法被实例化时,抛出该异常

相关推荐

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
©️2022 CSDN 皮肤主题:数字20 设计师:CSDN官方博客 返回首页

打赏作者

郭小闲

你的鼓励将是我创作的最大动力

¥2 ¥4 ¥6 ¥10 ¥20
输入1-500的整数
余额支付 (余额:-- )
扫码支付
扫码支付:¥2
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值